##Delayed Tick Function

schedule function mcdragon:delayed_tick 5t replace

#Dragon AI

#walk and idle
execute as @e[type=camel,tag=mcdragon,nbt={Motion:[0.0,-0.0784000015258789,0.0]}] at @s unless entity @a[distance=..3,sort=nearest,nbt={RootVehicle:{Entity:{Tags:["mcdragon"]}}}] run scoreboard players set @s DragonMovement 0
execute as @e[type=camel,tag=mcdragon,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]}] at @s unless entity @a[distance=..3,sort=nearest,nbt={RootVehicle:{Entity:{Tags:["mcdragon"]}}}] run scoreboard players set @s DragonMovement 1

#flying
execute as @e[type=camel,tag=mcdragon,nbt={OnGround:0b}] at @s run tag @s[tag=!mcdragonfly] add mcdragonfly
execute as @e[type=camel,tag=mcdragon,nbt={OnGround:1b}] at @s run tag @s[tag=mcdragonfly] remove mcdragonfly
#execute as @e[type=camel,tag=mcdragon,tag=!Cmcdragon] run data merge entity @s {Silent:1b,Tame:1b,Tags:["mcdragon","Cmcdragon"],Attributes:[{Name:generic.movement_speed,Base:0.3}],SaddleItem:{id:"minecraft:saddle",Count:1b}}
execute as @e[type=camel,tag=mcdragon] run effect give @s invisibility 200 10 true


#Move, Fly and Sit Animations
execute as @e[type=camel,tag=mcdragon,tag=!mcdragonfly] at @s if score @s DragonMovement matches 0 on passengers run function mcdragon:animations/mcdragonidle

execute as @e[type=camel,tag=mcdragon,tag=!mcdragonfly] at @s if score @s DragonMovement matches 1 on passengers run function mcdragon:animations/mcdragonmove

execute as @e[type=camel,tag=mcdragon,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]},tag=mcdragonfly] at @s if score @s DragonMovement matches 1 on passengers run function mcdragon:animations/mcdragonfly

execute as @e[type=camel,tag=mcdragon,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]},tag=mcdragonfly] at @s if score @s DragonMovement matches 3 on passengers run function mcdragon:animations/mcdragonhover

execute as @e[type=camel,tag=mcdragon,nbt={Motion:[0.0,-0.0784000015258789,0.0]},tag=!mcdragonfly] at @s run function mcdragon:animations/mcdragonsit


#Dragon Egg Summon
execute as @e[type=item,nbt={Item:{id:"minecraft:ender_eye",Count:1b}}] at @s if block ~ ~-0.5 ~ dragon_egg run function mcdragon:mcdragonmech/dragoneggspawn
execute at @e[type=minecraft:armor_stand,tag=mcdragonegg] run particle minecraft:portal ~ ~ ~ 0.1 0.1 0.1 0.5 1 force @a




#Dragon Egg Hatching.....
scoreboard players add @e[tag=mcdragonegg] DragonEggSpawn 1
execute as @e[tag=mcdragonegg,type=armor_stand] at @s if score @s DragonEggSpawn matches 1980..1999 run particle block dragon_egg ~ ~ ~ 0.3 0.3 0.3 0.6 2 force @a
execute as @e[tag=mcdragonegg,type=armor_stand] at @s if score @s DragonEggSpawn matches 2000.. run function mcdragon:mcdragonmech/dragonegghatching


#kill model
execute as @e[tag=mcdragon_model] at @s unless entity @e[tag=mcdragon,distance=..7] run kill @s
execute as @e[tag=mcdragon_glow] at @s unless entity @e[tag=mcdragon_model,distance=..3] run kill @s
execute as @e[tag=mcdragon_hurt] at @s unless entity @e[tag=mcdragon_model,distance=..3] run kill @s

#Dragon Sounds....
scoreboard players add @e[tag=mcdragon] DragonRoarTime 1

execute as @e[tag=mcdragon] at @s if score @s DragonRoarTime matches 1 run playsound minecraft:entity.ender_dragon.growl ambient @a ~ ~ ~ 1 1.5

execute as @e[tag=mcdragon] at @s if data entity @s HurtTime

execute as @e[tag=mcdragon] at @s run stopsound @a[distance=..3] * minecraft:entity.camel.dash_ready

scoreboard players set @e[tag=mcdragon,tag=mcdragonfly,scores={DragonFlapWing=17..}] DragonFlapWing 0
scoreboard players set @e[tag=mcdragon,scores={DragonRoarTime=250..}] DragonRoarTime 0

#Dragon Effects
execute as @e[type=camel,tag=mcdragon] at @s run function mcdragon:mcdragonmech/dragoneffects


#Dragon Food
function mcdragon:mcdragonmech/dragonfood

execute as @e[tag=mcdragon,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] run effect give @s minecraft:instant_health 1 2

execute as @e[tag=mcdragon,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] run playsound entity.panda.eat master @a ~ ~ ~ 1 0.8

execute as @e[tag=mcdragon,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] as @e[type=item,tag=dragonfood,distance=0..1.5] run kill @s


#saddled tag
tag @e[tag=mcdragon,nbt={SaddleItem:{id:"minecraft:saddle",Count:1b}}] add saddled
tag @e[tag=mcdragon,nbt=!{SaddleItem:{id:"minecraft:saddle",Count:1b}}] remove saddled

#Wand
execute as @a[scores={WandDetect=1..},nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",Count:1b,tag:{CustomModelData:382}}}] at @s run function mcdragon:mcdragonmech/dragonwand
scoreboard players reset @a[scores={WandDetect=1..}] WandDetect